/* Remember to change LED_COUNT to the number of led's on your strip, currently set to 14.
 * Pin 2 to ground will pause at the color
 * Pin 3 to ground will cycle the colours slower - PIN 3 High (default) will cycle fast. 
 */



#include <FastLED.h>
#define DATA_PIN 12
#define LED_COUNT 14 //104
#define COLOR_ORDER GRB

int colour_buttonPin = 2;     // Pause the colours
int colour_buttonState = 0;

int speed_buttonPin = 3; // Speed button
int speed_buttonState = 0;

bool is_red;
bool is_blue;
bool is_green;
bool is_green_2;
bool is_yellow;
bool is_yellow_2;
int colorStep = 0;
int r;
int g;
int b;
int delay_speed;

CRGB leds[LED_COUNT];

void setup() {

 is_red = true; // True -> Start with red
 is_blue = false;
 is_green = false;
 is_green_2 = false;
 is_yellow = false;
 is_yellow_2 = false;
 colorStep = 0;
 delay_speed = 1;
  
  FastLED.addLeds<WS2812, DATA_PIN, GRB>(leds, LED_COUNT);
  pinMode(colour_buttonPin, INPUT);
  digitalWrite(colour_buttonPin, HIGH);

  pinMode(speed_buttonPin, INPUT);
  digitalWrite(speed_buttonPin, HIGH);
  
  Serial.begin(9600);      // open the serial port at 9600 bps:
}

void loop() {

  colour_buttonState = digitalRead(colour_buttonPin);
  speed_buttonState = digitalRead(speed_buttonPin);

  if(speed_buttonState==LOW) {
    delay_speed=100;    
  } else {
    delay_speed=1;
  }
  
  if(colour_buttonState==LOW) {
     FastLED.clear();   
  } 
  else {

// RED -> PURPLE
  if(is_red==true) {      
    if(colorStep<=255){
       r=255;
       g=0;
       b=colorStep;    
       colorStep++;           
    } else {    
      if(is_red==true && is_blue==false && is_green==false && is_green_2==false && is_yellow==false && is_yellow_2==false) {
         is_red=false;
         is_blue=true;      
         colorStep=255;    
      }    
    }
  }

// PURPLE -> BLUE
  if(is_blue==true) {
    if(colorStep>=0) {    
       r=colorStep;    
       g=0;
       b=255;
       colorStep--;              
  } else {    
    if(is_blue==true && is_red==false && is_green==false && is_green_2==false && is_yellow==false && is_yellow_2==false) {
       is_blue=false;
       is_green=true;    
       colorStep=0;
    }
   }
 }

// BLUE -> TURQUOISE
  if(is_green==true) {
    if(colorStep<=255) {               
       r=0;    
       g=colorStep;
       b=255;    
       colorStep++;               
  } else {      
    if(is_green==true && is_red==false && is_blue==false && is_green_2==false && is_yellow==false && is_yellow_2==false) {
      is_green=false;
      is_green_2=true;           
      colorStep=255;     
    }
  }
 }

// TURQUOISE -> GREEN  
  if(is_green_2==true) {
    if(colorStep>=0) {               
       r=0;    
       g=255;
       b=colorStep;    
       colorStep--;                
  } else {   
    //Serial.println(is_green_2);   
    if(is_green_2==true && is_red==false && is_blue==false && is_green==false && is_yellow==false && is_yellow_2==false) {
      is_green_2=false;
      is_yellow=true;
      colorStep=0;     
    }
  }
 }

// GREEN -> YELLOW
 if(is_yellow==true) {
    if(colorStep<=255) {               
       r=colorStep;    
       g=255;
       b=0;   
       colorStep++;                   
  } else {    
    if(is_yellow==true && is_red==false && is_blue==false && is_green_2==false && is_green_2==false && is_yellow_2==false) {
      is_yellow=false;
      is_yellow_2=true;
      colorStep=255;      
    }
  }
 }

// YELLOW -> RED
  if(is_yellow_2==true) {
    if(colorStep>=0) {               
       r=255;    
       g=colorStep;
       b=0;   
       colorStep--;                   
  } else {    
    if(is_yellow_2==true && is_red==false && is_blue==false && is_green_2==false && is_green_2==false && is_yellow==false) {
      is_yellow_2=false;
      is_red=true;
      colorStep=0;      
    }
  }
 }

}

 for (int x = 0; x < LED_COUNT; x++) {
      leds[x] = CRGB(r, g, b);
 }

delay(delay_speed);
FastLED.show();
}

  


